/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement count
open core

facts
counter : integer:=0.

constants
className = "com/rudstrand/count/count".
classVersion = "1.0".

clauses
classInfo(className, classVersion).

new() :- counter:=0,!.
new(Init) :- counter:=Init,!.
newCounter(Init) :- new(Init),!.
set(Init) :- counter:=Init,!.
get() = V :- V=counter,!.
inc() :- counter:=counter+1,!.
inc(AfterInc) :- AfterInc=counter+1, counter:=AfterInc,!.
dec() :- counter:=counter-1,!.
dec(AfterDec) :- AfterDec=counter-1, counter:=AfterDec,!.
add(Add) :- counter:=counter+Add,!.
add(Add,AfterAdd) :- AfterAdd=counter+Add, counter:=AfterAdd,!.
% -----------------------------------------------------------------------------------------------
% setMax/Min
% -----------------------------------------------------------------------------------------------
setMax(V) :-
	get()>=V,
	!
;
	set(V),
	!.	

setMin(V) :-
	get()<=V,
	!
;
	set(V),
	!.	

end implement count
