/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class globalVars
open core,termDomain

predicates
classInfo : core::classInfo.

popRetPars : () -> string_list determ.
pushRetPars : (string_list).

load : (string File,string_list Includes).
save : (string File,string_list Includes).

iVp : (string GlobalVar,integer Val) nondeterm (o,o).
sVp : (string GlobalVar,string Val) nondeterm (o,o).
nVp : (string GlobalVar,real Val) nondeterm (o,o).

get_i : (string GlobVar) -> integer determ.
get_n : (string GlobVar) -> real determ.
get_s : (string GlobVar) -> string determ.
get_t : (string GlobVar) -> sterm determ.
set_i : (string GlobVar,integer N) procedure (i,i).
set_n : (string GlobVar,real N) procedure (i,i).
set_s : (string GlobVar,string S) procedure (i,i).
set_t : (string GlobVar,sterm S) procedure (i,i).
drop_t : (string GlobVar).
getc_i : (integer Def,string Var) -> integer.
getc_s : (string Def,string Var) -> string.

add : (string GlobVar,integer Add,integer After) determ (i,i,o). 
incr : (string GlobVar,integer Current,integer Inc) determ (i,o,o). 
decr : (string GlobVar,integer Current,integer Inc) determ (i,o,o).
setMax_i : (string GlobVar,integer Current) procedure.
setMin_i : (string GlobVar,integer Current) procedure.
end class globalVars