/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class pie_scan
open core

domains

op	= string.	          % Storing of operators
xfy	= string.	          % xfy; yfx; xfx; yfy; fx; fy; xf; yf
assoc   = x; y.		          % The associavity to the left or the right
prior   = integer.	          % Priority of operators
mode = symbol.	          % Display mode for term writer

tok	= lbrack; rbrack; lpar; rpar; lcurly; rcurly;
		  var(string);	
		  atom(string);
		  int(integer);
		  str(string);
		  chr(char);      % formerly chr was char
		  fix(real);		% Pro/3 addition
		  gvar(string);   % Pro/3 addition: #-type genuine variable
		  hex(string);    % Clan addition: to be able to scan e.g. pie_scan
		  comma; 
		  bar; 
		  dot.
cursor_position	= integer.
cursortok	= t(tok,cursor_position).
tokl  = cursortok*.
wrd        = w(integer,string,string,string).
wrds       = wrd*.
wrds_list = wrds*.

predicates

classInfo : core::classInfo.
tokl : (cursor_position,string,tokl) determ(i,i,o).

end class pie_scan