/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

interface rep
open core

predicates
cancelled : () determ.
close : () determ.
close : (integer) determ.
getFileName : () -> string.
getName : () -> string.
getWidth : () -> integer.
getPrinter : () -> integer.
getLines : () -> string_list.

textBlock : (integer Indent,string Heading,string Text) determ.
textBlock : (integer Indent,integer Width,string Heading,string Text) determ.
repBlock : (string,integer,integer) determ.
repLine : (char) determ.
repList : (integer Indent,string_list) determ.
repWL : (integer Indent,string) determ.
repWL : (integer Indent,string,string) determ.
repWL : (integer Indent,string,string,string) determ.
repWL : (integer Indent,string,string,string,string) determ.
repWL : (integer Indent,string,string,string,string,string) determ.
repWL : (integer Indent,string,string,string,string,string,string) determ.
repWL : (integer Indent,string,string,string,string,string,string,string) determ.
repWL : (integer Indent,string,string,string,string,string,string,string,string) determ.
repWL : (integer Indent,string,string,string,string,string,string,string,string,string) determ.
repW : (integer Indent,string) determ.
repW : (integer Indent,string,string) determ.
repW : (integer Indent,string,string,string) determ.
repW : (integer Indent,string,string,string,string) determ.
repW : (integer Indent,string,string,string,string,string) determ.
repW : (integer Indent,string,string,string,string,string,string) determ.
repW : (integer Indent,string,string,string,string,string,string,string) determ.
repW : (integer Indent,string,string,string,string,string,string,string,string) determ.
repW : (integer Indent,string,string,string,string,string,string,string,string,string) determ.
end interface rep