/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class set
open core,termDomain,globalDomains

domains

predicates
classInfo : core::classInfo.

conc : (sterml_list,sterml) procedure (i,o).
conc : (string_list_list,string_list) procedure (i,o).
conc : (integer_list_list,integer_list) procedure (i,o).
conc : (real_list_list,real_list) procedure (i,o).
conc : (vpiTree::tree_lists,vpiTree::tree_list) procedure (i,o).
conc : (menuItem_lists,vpiDomains::menuItem_list) procedure (i,o).
conc : (vpiTableed::tableedit_DATA,vpiTableed::tableedit_COLUMNDATA) procedure (i,o).
conc : (tableedit_DATA_list,vpiTableed::tableedit_DATA) procedure (i,o).
conc : (windef_list_list,vpiDomains::windef_list) procedure (i,o).
conc : (dbLoc_list_list,dbLoc_list) procedure (i,o).
front : (integer N,integer_list S,integer_list S1toN,integer_list Tail) determ (i,i,o,o).
front : (integer N,string_list S,string_list S1toN,string_list Tail) determ (i,i,o,o).
front : (integer N,real_list S,real_list S1toN,real_list Tail) determ (i,i,o,o).
front : (integer N,sterml S,sterml S1toN,sterml Tail) determ (i,i,o,o).
intersection : (integer_list SetA,integer_list SetB,integer_list Intersection) determ (i,i,o).
intersection : (real_list SetA,real_list SetB,real_list Intersection) determ (i,i,o).
intersection : (string_list SetA,string_list SetB,string_list Intersection) determ (i,i,o).
intersection : (sterml SetA,sterml SetB,sterml Intersection) determ (i,i,o).
invertToColMajorOrder : (string_list_list,string_list_list) determ (i,o).
invertToColMajorOrder : (integer_list_list,integer_list_list) determ (i,o).
invertToColMajorOrder : (real_list_list,real_list_list) determ (i,o).
invertToColMajorOrder : (sterml_list,sterml_list) determ (i,o).
sort : (string_list,string_list) procedure (i,o).
sort : (integer_list,integer_list) procedure (i,o).
sort : (real_list,real_list) procedure (i,o).
distinct : (string_list SL,string_list S) procedure (i,o).
distinct : (integer_list IL,integer_list I) procedure (i,o).
distinct : (real_list RL,real_list R) procedure (i,o).
distinct : (sterml TL,sterml T) procedure (i,o).
setEq : (string_list SL,string_list S) determ.
setEq : (integer_list IL,integer_list I) determ.
setEq : (real_list RL,real_list R) determ.
setEq : (sterml TL,sterml T) determ.
setGetI : (integer_list IL,integer Ix,integer I) determ (i,i,o) (i,o,i).
setGet : (integer_list IL,integer Ix,integer I) determ (i,i,o) (i,o,i).
setGet : (real_list RL,integer Ix,real R) determ (i,i,o) (i,o,i).
setGet : (string_list SL,integer Ix,string S) determ (i,i,o) (i,o,i).
setGet : (sterml TL,integer Ix,sterm T) determ (i,i,o) (i,o,i).
setGet : (dbLoc_list TL,integer Ix,dbLoc T) determ (i,i,o) (i,o,i).
setGet : (windowHandle_list TL,integer Ix,vpiDomains::windowHandle T) determ (i,i,o) (i,o,i).
initialize : (integer,string,string_list) procedure (i,i,o).
initialize : (integer,integer,integer_list) procedure (i,i,o).
initialize : (integer,real,real_list) procedure (i,i,o).
initialize : (integer,sterm,sterml) procedure (i,i,o).
max : (integer_list) -> integer determ.
max : (real_list) -> real determ.
setMax : (integer_list,integer) determ (i,o). % old
setMax : (real_list,real) determ (i,o). % old
min : (integer_list) -> integer determ.
min : (real_list) -> real determ.
minus : (string_list Set1,string_list Set2)->string_list. % =Set1-Set2
removeElement : (string Element,string_list Set1)->string_list. % =Set1-{Element}
setMin : (integer_list,integer) determ (i,o). % old
setMin : (real_list,real) determ (i,o). % old
sum : (integer_list) -> integer.
sum : (real_list) -> real.
member : (integer M, integer_list Set) determ (i,i).
member : (string M, string_list Set) determ (i,i).
member : (real M, real_list Set) determ (i,i).
member : (sterm T, sterml Set) determ (i,i).
setRem : (string_list SL,integer Ix,string_list) determ (i,i,o).
setRem : (integer_list,integer,integer_list) determ (i,i,o).
setRem : (real_list,integer,real_list) determ (i,i,o).
setRem : (sterml,integer,sterml) determ (i,i,o).
setRemFront : (string_list SL,integer Ix,string_list) determ (i,i,o).
setRemFront : (integer_list,integer,integer_list) determ (i,i,o).
setRemFront : (real_list,integer,real_list) determ (i,i,o).
setRemFront : (sterml,integer,sterml) determ (i,i,o).
setRemSub : (integer_list Rem,integer_list Set,integer_list NewSet) determ (i,i,o).
setRemSub : (real_list Rem,real_list Set,real_list NewSet) determ (i,i,o).
setRemSub : (string_list Rem,string_list Set,string_list NewSet) determ (i,i,o).
setRemSub : (sterml Rem,sterml Set,sterml NewSet) determ (i,i,o).
setReplace : (sterml Set,integer Index,sterm New,sterml SetReplaced) determ (i,i,i,o).
setReplace : (string_list,integer,string,string_list) determ (i,i,i,o).
setReplace : (integer_list,integer,integer,integer_list) determ (i,i,i,o).
setReplace : (real_list,integer,real,real_list) determ (i,i,i,o).
replaceMember : (sterml Set,sterm,sterm New,sterml SetReplaced) determ (i,i,i,o).
replaceMember : (string_list,string,string,string_list) determ (i,i,i,o).
replaceMember : (integer_list,integer,integer,integer_list) determ (i,i,i,o).
replaceMember : (real_list,real,real,real_list) determ (i,i,i,o).
setNos : (string_list SetList,string_list Members,integer_list MemberNos) determ (i,i,o).
setRev : (string_list SL,string_list S) procedure (i,o).
setRev : (integer_list IL,integer_list I) procedure (i,o).
setRev : (real_list RL,real_list R) procedure (i,o).
setRev : (sterml TL,sterml T) procedure (i,o).
setRev : (vpiTree::tree_list,vpiTree::tree_list) procedure (i,o).
size : (integer_list Set,integer Size) procedure (i,o).
size : (real_list Set,integer Size) procedure (i,o).
size : (string_list Set,integer Size) procedure (i,o).
size : (sterml Set,integer Size) procedure (i,o).
size : (dbLoc_list Set,integer Size) procedure (i,o).
setCount : (integer,integer_list,integer) procedure (i,i,o).
setCount : (real,real_list,integer) procedure (i,i,o).
setCount : (string,string_list,integer) procedure (i,i,o).
setCount : (sterm,sterml,integer) procedure (i,i,o).
setCountL : (sterm,sterm,integer) procedure (i,i,o).
% succeeds if SubSequence is a sub-sequence of Sequence i.e. similar to string::search (returns the 0-based position if success)
search : (string_list Sequence,string_list SubSequence) -> integer determ.
search : (integer_list IL,integer_list I) -> integer determ.
search : (real_list RL,real_list R) -> integer determ.
search : (sterml TL,sterml T) -> integer determ.
trunc : (integer Max,string_list SL,string_list S) procedure (i,i,o).
trunc : (integer Max,integer_list IL,integer_list I) procedure (i,i,o).
trunc : (integer Max,real_list RL,real_list R) procedure (i,i,o).
trunc : (integer Max,sterml TL,sterml T) procedure (i,i,o).

end class set