/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class ted
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.

createTableWin : (vpiDomains::windowHandle Parent,string WinTitle,integer NRows,integer_list ReadOnly,string_list ColHeaders,integer_list ColWidths,
                           integer_list Aligns,vpiTableed::tableedit_DATA,string_list Buttons,integer Sort,vpiDomains::ehandler EHANDLER,integer Cascade) -> vpiDomains::windowHandle determ.
% ReadOnly: one flag per data column (1=read only, 0=not read only)
% Alings: one flag per data column (-1 left, 0 center, 1 right)
getCount : () -> integer.
getButtons : () -> string_list determ.
makeCell : (sterm,string,vpiTableed::tableedit_CELLDATA) determ (i,i,o). % Pro/3 table cells
makeCell_s : (string,vpiTableed::tableedit_CELLDATA) determ (i,o). % Pro/3 table lay-out cells
makeCell_i : (integer,vpiTableed::tableedit_CELLDATA) determ (i,o). % Pro/3 table lay-out cells
makeDataOfPackedStrings : (string_list Rows,color_list,vpiTableed::tableedit_DATA) determ (i,i,o). % each row is a string with format Col1|Col2|Col3...
makeDataOfCmp : (sterml Rows,vpiTableed::tableedit_DATA) determ (i,o).
makeDataOfPackedStringsInv : (string_list Rows,color_list,vpiTableed::tableedit_DATA) determ (i,i,o).
setColProp : (vpiDomains::windowHandle,integer,integer) determ.
getColsX : (integer_list,string_list,integer_list,integer_list,vpiTableed::tableedit_COLUMNLIST) determ (i,i,i,i,o).
end class ted