/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/
/* 
The termSet class generates termSet objects which are (unordered) sets of sterm's. 
The interface includes simple operations on the set. 
*/
interface termSet
open core,termDomain

predicates

add : (sterm).
addList : (sterml).
delete : (sterm) determ.
get_nd : () -> sterm nondeterm.
get : () -> sterml.
member : (sterm) determ.
subtract : (termSet).
size : () -> integer determ.
union : (termSet).

end interface termSet