/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class globalRefDomains
open core
domains
% PIE v.6:
refint = reference integer.
refsymb = reference string.
refstr = reference string.
refchar = reference char.
vid = reference string.
% Pro/3 additions:
refreal = reference real. 
refreals = refreal*.
refints = refint*.
refstrs = refstr*.

terml = reference term*.
term  = reference
        var(vid);
        cmp(refsymb,terml);
        list(term,term);
        nill;
        atom(refsymb);
        int(refint);
        str(refstr);
        chr(refchar); % formerly chr was char
        % Pro/3 additions:
		fix(refreal); 
		fvar(vid,refstr);	
		fint(refint,refstr);
		ffix(refreal,refstr);
		fstr(refstr,refstr,refstr,refint).

e = reference e(vid,term).
env = reference e*.

predicates
classInfo : core::classInfo.
end class globalRefDomains