/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement projectToolbar
    open core, vpiDomains, vpiToolbar, resourceIdentifiers

    constants
        className = "com/rudstrand/TaskWindow/Toolbar/projectToolbar".
        classVersion = "1.0".

    clauses
        classInfo(className, classVersion).
    clauses
        create(Parent):-
            _ = vpiToolbar::create(style, Parent, controlList).

    % This code is maintained by the VDE do not update it manually, 21:31:20-7.11.2005
constants
    style : vpiToolbar::style = tb_top().
    controlList : vpiToolbar::control_list =
        [
        tb_ctrl(id_file_new,pushb(),resId(idb_NewFileBitmap),"Open new file",1,1),
        tb_ctrl(id_file_open,pushb(),resId(id_OpenFileBitmap),"Open existing file",1,1),
        tb_ctrl(id_file_recent_files,pushb(),resId(idb_recent),"Display recently opened files",1,1),
        tb_ctrl(id_file_save,pushb(),resId(id_SaveFileBitmap),"Save editor window to file",1,1),
        vpiToolbar::separator,
        tb_ctrl(id_file_print,pushb(),resId(idb_print),"Print",1,1),
        vpiToolbar::separator,
        tb_ctrl(id_edit_undo,pushb(),resId(id_UndoBitmap),"Undo edit",1,1),
        tb_ctrl(id_edit_redo,pushb(),resId(id_RedoBitmap),"Redo edit",1,1),
        vpiToolbar::separator,
        tb_ctrl(id_edit_cut,pushb(),resId(id_CutBitmap),"Cut edit",1,1),
        tb_ctrl(id_edit_copy,pushb(),resId(id_CopyBitmap),"Copy edit",1,1),
        tb_ctrl(id_edit_paste,pushb(),resId(id_PasteBitmap),"Paste edit",1,1),
        vpiToolbar::separator,
        vpiToolbar::separator,
        tb_ctrl(id_file_process,pushb(),resId(idb_process),"Process window",1,1),
        vpiToolbar::separator,
        vpiToolbar::separator,
        tb_ctrl(id_Knowledge_base_realmschains,pushb(),resId(idb_realms),"Open Realm/Chains windows",1,1),
        tb_ctrl(id_Structure_context,pushb(),resId(id_Structure_context),"Open context window",1,1),
        tb_ctrl(id_Sentences_list_sentences,pushb(),resId(idb_sentences),"Open Sentences window",1,1),
        tb_ctrl(id_Preferences_output_format,pushb(),resId(idb_outpref),"Open Output Preferences window",1,1),
        tb_ctrl(id_Preferences_processing,pushb(),resId(idb_procpref),"Open Processing Preferences window",1,1),
        tb_ctrl(id_Preferences_directories_and_files,pushb(),resId(idb_dirpref),"Open Directory and File Preferences window",1,1),
        vpiToolbar::separator,
        tb_ctrl(id_Sentences_table_layout,pushb(),resId(idb_layout),"Open Table-Layout window",1,1),
        vpiToolbar::separator,
        tb_text(idt_2,tb_static(),48,0,4,8,0x0,"Caches:"),
        tb_text(idt_cache,tb_static(),32,1,4,13,0x80,""),
        tb_ctrl(idt_tmc,pushb(),resId(idb_tmcache),"Terminology Cache ON/OFF toggle",1,1),
        tb_ctrl(idt_smc,pushb(),resId(idb_smcache),"Sentence Model Cache ON/OFF toggle",1,1),
        vpiToolbar::separator,
        tb_text(idt_22,tb_static(),37,0,4,8,0x0,"Flags:"),
        tb_text(idt_flags,tb_static(),62,1,4,12,0x80,""),
        tb_ctrl(id_file_reset_quit_and_error_flags,pushb(),resId(idb_reset),"Reset quit and error flags",1,1),
        vpiToolbar::separator,
        tb_text(idt_tracelevel,tb_static(),20,0,4,8,0x0,""),
        tb_ctrl(id_change_trace,pushb(),resId(idb_trace),"Change trace level",1,1),
        vpiToolbar::separator,
        tb_ctrl(id_help_active_window,pushb(),resId(id_HelpBitmap),"Help - active window",1,1),
        vpiToolbar::separator,
        tb_ctrl(id_Preferences_reset_window_cascadeposition,pushb(),resId(idb_cascade),"Reset window cascading position",1,1),
        tb_ctrl(id_file_display_assistantwindow_on_top,pushb(),resId(idb_assistant),"Display Assistant-window on top",1,1)
        ].
    % end of automatic code
end implement projectToolbar
