/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class conversion
open core,termDomain

predicates
classInfo : core::classInfo.

bool : (integer) -> booleanInt determ.
realRefType : (sterm,globalRefDomains::refreal) determ (i,o).
realsRefType : (sterml,globalRefDomains::refreals) determ (i,o).
intRefType : (sterm,globalRefDomains::refint) determ (i,o).
intsRefType : (sterml,globalRefDomains::refints) determ (i,o).
strRefType : (sterm,globalRefDomains::refstr) determ (i,o).
strsRefType : (sterml,globalRefDomains::refstrs) determ (i,o).
sterm_term : (sterm,globalRefDomains::term) determ (i,o). 
term_sterm : (globalRefDomains::term,sterm) determ (i,o). 
intToReal : (integer) -> real.
realToIntT : (real) -> integer.
realToIntR : (real) -> integer.
toStrings : (sterml,string_list) determ (i,o).
toStringsR : (sterml,string_list) determ (o,i).
toTree : (sterm) -> vpiTree::tree determ.
fromTree : (vpiTree::tree) -> sterm determ.
end class conversion