/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class dbaLib
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.
%
% Chain-related
%
chainTerms : (string Chain,sterm LT,sterm RT) nondeterm (i,o,o).
chainTerms : (string Chain,sterm LT,sterm RT,dbLoc) nondeterm (i,o,o,o).
chainTermsAll : (string Chain,sterm LT,sterm RT) nondeterm (i,o,o).
chainTermsAll : (string Chain,sterm LT,sterm RT,dbLoc) nondeterm (i,o,o,o).
chainTermsAll : (string Chain,sterm LT,sterm RT,dbLoc,integer RecType) nondeterm (i,o,o,o,o).
%
% Realm-related
%
realmRename : (string From,string To,integer N) procedure (i,i,o).
%
% ST-related
%
stList : () -> string_list.
stBasetypes : (integer Basetype) -> string_list.
%
% Index-related
%
ixsInsert : (chainDB,chainDB::ref,clause) determ. % inserts all relevant indexes at record insert
ixsDelete : (chainDB,chainDB::ref,clause) determ. % deletes all relevant indexes at record delete
end class dbaLib