/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class fioExt
open core

predicates
classInfo : core::classInfo.

filChangeType : (string OldFile,string NewType,string NewFile) procedure (i,i,o).
filDirEnd : (string S,string Dir) determ (i,o).
setType : (string Name,string Type) -> string procedure.
setDefaultPath : (string File) -> string procedure.
inPathList : (string Path,string_list PathList) determ.
% relationship between output format codes and file extensions
file_type : (integer,string) procedure (i,o).
filCheckFile : (integer Context,string Message,string RequestedFile,string ActualFile) determ (i,i,i,o).
filGenName : (integer,string,string,string,string) determ (i,i,i,i,o).
filValidKB_Name : (integer Warning,string Name,string KB_Name) determ (i,i,o).
makeFileName : (string NL,string Type,string FileName) determ (i,i,o). % generates a file name from a NL text
makeRealmName : (string File) -> string determ. 
getPath : (string Dir,string File) -> string determ.
end class fioExt