/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class irBase
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.

seriesLoc : (string Rule) -> dbLoc determ.
seriesLocF : (string Rule) -> dbLoc determ.
clusterLoc : (string Rule,string Prompt) -> dbLoc determ.
clusterLocF : (string Rule,string Prompt) -> dbLoc determ.

wcrAdjustCallParsR : (sterml,sterml) determ (o,i).
isSubType : (string SubType,sterm RuleBody) determ.
wcrQuestionToIF : (string,string) determ (i,o).
wcrQuestionToNL : (string,string) determ (i,o).
wcrQuestionAltsToNL : (string,string) procedure (i,o).
wcrSetType : (string,string) procedure (i,o).
wcrTransQuery : (string,sterm,string) determ (i,o,o).
wcrTransQuestion : (string,sterm) determ (i,o).

crtReasonTree : (sterm,sterm,string,sterml,sterml,vpiTree::tree_list,vpiTree::tree) determ (i,i,i,i,i,i,o).
crtReasonTreeMap : (sterm,sterm,sterm,string,sterml,sterml,vpiTree::tree_list,vpiTree::tree) determ (i,i,i,i,i,i,i,o).
crtReasonTreeAdd : (vpiTree::tree,vpiTree::tree_list,vpiTree::tree) procedure (i,i,o).
crtReasonName : (sterm,sterm,sterm,string,string,string,sterml,sterml,string,integer) determ (i,i,i,i,i,i,i,i,o,o).
crtTreePrefix : (string,vpiTree::tree,vpiTree::tree) determ (i,i,o).
crtTreePrefixes : (string,vpiTree::tree_list,vpiTree::tree_list) determ (i,i,o).
crtSaveTree : (string,string,string,sterml,vpiTree::tree).

unpackQuestion : (string,string,string,string_list) procedure (i,i,o,o).
crtSubstActPars : (sterml,sterml,sterml,sterml) determ (i,i,i,o).
crtSetQueryPars : (string,sterm,string_list,sterml,sterm) determ (i,i,i,i,o).
crtMatchPars : (sterml,sterml) determ (i,i).
setQuestionPars : (string,string,sterml,sterml,string) determ (i,i,i,i,o).
setInpFacPars : (string,string,string_list,sterml,string) determ (i,i,i,i,o).	
queryInpFac : (string,string) -> termSet determ.

crtCombineBay : (real,real,real,real,real,real) procedure (i,i,i,i,i,o).
crtCombine : (real,real,real) procedure (i,i,o).
evaluateCondition : (string,sterm,string,sterm,sterm) determ (i,i,i,i,i).
crtToFix : (sterm,real) determ (i,o).
crtMapN : (sterm,real_list,real_list,real) determ (i,i,i,o).
crtMapD : (sterm,sterml,sterml,sterm) determ (i,i,i,o).

bayesfactor : (real,real,real,real,real) procedure (i,i,i,i,o).
probtocert : (real,real,real) procedure (i,i,o).
certtoprob : (real,real,real) procedure (i,i,o).
probtoodds : (real,real) procedure (i,o).
oddstoprob : (real,real) procedure (i,o).
end class irBase