/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement loop
open core,globalDomains

facts
loopEnd : integer := 0.
loopInc : integer :=0.
loopNext : integer := 0.

constants
    className = "com/rudstrand/loop/loop".
    classVersion = "1.0".

clauses
classInfo(className, classVersion).

new(Start,End,Inc) :-
    Inc>0,
    End>=Start,
    loopEnd:=End,
    loopInc:=Inc,
    loopNext:=Start,
    !
;
    Inc<0,
    End<=Start,
    loopEnd:=End,
    loopInc:=Inc,
    loopNext:=Start,
    !
;
    dlgIF::feil("new/loop",["Invalid loop parameters"],[Start,End,Inc],nill),
    !;!.    
    
next () = N :-
   N=loopNext,
   N>loopEnd,
   !,fail
;
    N=loopNext,
    Inc=loopInc,
    loopNext:=N+Inc.
end implement loop
