/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement pie_op
open core

constants
className = "com/rudstrand/pie_op/pie_op".
classVersion = "1.0".

class facts
op : (pie_scan::prior,pie_scan::xfy,pie_scan::op).

clauses
classInfo(className, classVersion).

op(1200,"xfx",":-").
op(1100,"xfy",";").
op(1000,"xfy",",").
op(900,"fy","not").
op(700,"xfx","=").
%op(700,"xfx","\\="). 
op(700,"xfx","is").
op(700,"xfx","<").
%op(700,"xfx","=<"). 
op(700,"xfx","<="). % Pro/3
op(700,"xfx",">").
op(700,"xfx",">=").
op(700,"xfx","inside"). % Pro/3
op(700,"xfx","outside"). % Pro/3
%op(700,"xfx","=="). 
%op(700,"xfx","\\=="). 
%op(700,"xfx","=..").
op(700,"xfx","<>").
%op(700,"xfx","><"). 
op(500,"yfx","+").
op(500,"yfx","-").
op(450,"yfx","^"). % Pro/3
op(400,"yfx","*").
op(400,"yfx","/").
op(400,"yfx","div").
op(300,"xfx","mod").
op(200,"fx","+").
op(200,"fx","-").
% Pro/3 domain-qualified 'is':
op(700,"xfx","isIN").
op(700,"xfx","isNU").
op(700,"xfx","isLI").
op(700,"xfx","isIF").
op(700,"xfx","isIT").
op(700,"xfx","isID").
op(700,"xfx","isSY").
op(700,"xfx","isCF").
op(700,"xfx","isMG").
op(700,"xfx","isKB").
op(700,"xfx","isINC").
op(700,"xfx","isDEC").
op(700,"xfx","isPR").
op(700,"xfx","isANY").
op(700,"xfx","isXT").
op(700,"xfx","isXD").
op(700,"xfx","isXDT").
op(700,"xfx","isXDR").
op(700,"xfx","isTS").
op(700,"xfx","isIN_L").
op(700,"xfx","isNU_L").
op(700,"xfx","isLI_L").
op(700,"xfx","isIF_L").
op(700,"xfx","isIT_L").
op(700,"xfx","isID_L").
op(700,"xfx","isSY_L").
op(700,"xfx","isCF_L").
op(700,"xfx","isMG_L").
op(700,"xfx","isKB_L").
op(700,"xfx","isINC_L").
op(700,"xfx","isDEC_L").
op(700,"xfx","isPR_L").
op(700,"xfx","isANY_L").
op(700,"xfx","isXT_L").
op(700,"xfx","isXD_L").
op(700,"xfx","isXDT_L").
op(700,"xfx","isXDR_L").
op(700,"xfx","isTS_L").
op(700,"xfx","nisIN").
op(700,"xfx","nisNU").
op(700,"xfx","nisLI").
op(700,"xfx","nisIF").
op(700,"xfx","nisIT").
op(700,"xfx","nisID").
op(700,"xfx","nisSY").
op(700,"xfx","nisCF").
op(700,"xfx","nisMG").
op(700,"xfx","nisKB").
op(700,"xfx","nisINC").
op(700,"xfx","nisDEC").
op(700,"xfx","nisPR").
op(700,"xfx","nisANY").
op(700,"xfx","nisXT").
op(700,"xfx","nisXD").
op(700,"xfx","nisXDT").
op(700,"xfx","nisXDR").
op(700,"xfx","nisTS").
op(700,"xfx","nisIN_L").
op(700,"xfx","nisNU_L").
op(700,"xfx","nisLI_L").
op(700,"xfx","nisIF_L").
op(700,"xfx","nisIT_L").
op(700,"xfx","nisID_L").
op(700,"xfx","nisSY_L").
op(700,"xfx","nisCF_L").
op(700,"xfx","nisMG_L").
op(700,"xfx","nisKB_L").
op(700,"xfx","nisINC_L").
op(700,"xfx","nisDEC_L").
op(700,"xfx","nisPR_L").
op(700,"xfx","nisANY_L").
op(700,"xfx","nisXT_L").
op(700,"xfx","nisXD_L").
op(700,"xfx","nisXDT_L").
op(700,"xfx","nisXDR_L").
op(700,"xfx","nisTS_L").

getOp(PRIOR,XFY,OP) :- op(PRIOR,XFY,OP), !.
getOp_nd(PRIOR,XFY,OP) :- op(PRIOR,XFY,OP).

setOp(PRIOR,XFY,OP) :-
      retractall(op(_,_,OP)),
      assert(op(PRIOR,XFY,OP)).

end implement pie_op
