/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class piex
open core,termDomain

predicates
classInfo : core::classInfo.
plcBasicValue : (sterm,sterm) determ (i,o).
plcNDERF : (string,sterm,sterm) nondeterm (i,i,o).
plcNDERF_Set : (string,sterm) -> termSet.
plcDDERF : (string,sterm,sterm) determ (i,i,o).
plcDomVal : (sterm,string,sterm) determ (i,i,o).
plcExists : (sterm) determ (i).
plcFunc : (string,sterm,sterm) determ (i,i,o).
procedureCall : (string,string,string,string,sterml) nondeterm (i,i,i,i,o).
plcRecursiveD : (integer,string,string,string,sterm) determ (i,i,i,i,o).
plcRecursiveN : (integer,string,string,string,sterm) nondeterm (i,i,i,i,o).
plcSSS : (sterm,sterm) determ (i,o).
plcTraceIn : (globalRefDomains::refint) determ (i).
plcTraceNu : (globalRefDomains::refreal) determ (i).
plcTraceS : (string,globalRefDomains::refstr) determ (i,i).
p3_fConc : (string,globalRefDomains::refstrs) determ (o,i).
p3_fUpp : (string,globalRefDomains::refstr) procedure (o,i).
p3_fLow : (string,globalRefDomains::refstr) procedure (o,i).
p3_fSubstr : (string,globalRefDomains::refstr,globalRefDomains::refint,globalRefDomains::refint) procedure (o,i,i,i).
p3_fGT_I : (integer,globalRefDomains::refints) determ (o,i).
p3_fLT_I : (integer,globalRefDomains::refints) determ (o,i).
p3_fGT_XD : (string,globalRefDomains::refstrs) determ (o,i).
p3_fLT_XD : (string,globalRefDomains::refstrs) determ (o,i).
p3_fGT_XDT : (string,globalRefDomains::refstrs) determ (o,i).
p3_fLT_XDT : (string,globalRefDomains::refstrs) determ (o,i).
p3_fGT_XT : (string,globalRefDomains::refstrs) determ (o,i).
p3_fLT_XT : (string,globalRefDomains::refstrs) determ (o,i).
p3_fGT_XR : (string,globalRefDomains::refstrs) determ (o,i).
p3_fLT_XR : (string,globalRefDomains::refstrs) determ (o,i).
p3_fMax : (real,globalRefDomains::refreals) determ (o,i).
p3_fMin : (real,globalRefDomains::refreals) determ (o,i).
p3_fIxIN : (integer,integer,globalRefDomains::refints,globalRefDomains::refint) determ (o,i,i,i).
p3_fSeq_I : (integer,globalRefDomains::refint,globalRefDomains::refint,globalRefDomains::refint) nondeterm (o,i,i,i). 
p3_fSeq_D : (string,string,string,string) nondeterm (o,i,i,i). 
p3_fSeq_T : (string,string,string,string) nondeterm (o,i,i,i). 
p3_fSeq_DT : (string,string,string,string) nondeterm (o,i,i,i). 
p3_fSeq_N : (real,globalRefDomains::refreal,globalRefDomains::refreal,globalRefDomains::refreal) nondeterm (o,i,i,i). 

end class piex