/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

/* db indpendent */

class rub
open core,termDomain

predicates
classInfo : core::classInfo.
rubCountNodes : (sterm,integer) procedure (i,o).
rubDE_Add : (integer,vpiDomains::windowHandle,string,string,string_list,string_list) determ (i,i,i,i,i,o).
rubDE_Adjust : (string_list,string_list,string_list) determ (i,o,o).
rubDE_Var : (string,integer,string,string) procedure (i,i,i,o).
rubDE_VarDom : (string,string) determ (i,o).
rubDEs : (integer,integer,vpiDomains::windowHandle,string_list) determ (i,i,i,o).
rubDummyAss : (integer,string_list,sterml) determ (i,i,o).
rubElimDEs : (sterm,string_list,string_list) procedure (i,i,o).	
rubFirstNIL : (sterm,integer,integer) procedure (i,i,o).
rubGetDEsK : (vpiDomains::windowHandle,integer,string,string,string,integer,string_list,string_list,string_list) determ (i,i,i,i,i,i,o,o,o).
rubGetDVs : (sterm,string_list,string_list,string_list) procedure (i,o,o,o).
rubIsNill : (sterm) determ (i).
rubIsVar : (string,string,string) determ (i,o,o).	
rubListHead : (string,string,string) determ (i,o,o).
rubNL : (sterm,sterm) determ (i,o).
rubNodeDelete : (sterm,integer,integer_list,string_list,sterm) determ (i,i,i,i,o).
rubNodeGet : (sterm,integer,sterm) determ (i,i,o).
rubNodeGetCurr : (vpiDomains::windowHandle,integer,string,integer,string) determ (i,o,o,o,o).
rubNodeNo : (sterm,integer) determ (i,o).
rubNIS_Current : (vpiDomains::windowHandle,integer,string,integer_list,string_list) determ (i,o,o,o,o).
rubNIS_Trace : (vpiDomains::windowHandle,integer,integer,sterm,integer_list,integer_list,string_list,string_list) procedure (i,i,i,i,i,o,i,o).
rubNodeSetCurr : (vpiDomains::windowHandle,integer) determ (i,i).
rubNodeText : (vpiDomains::windowHandle,integer,string) determ (i,i,o).
rubOprDom : (string,string,string) procedure (i,i,o).
rubOprType : (string,integer,integer,integer) determ (i,o,o,o).
rubRuleType : (string,integer,string) determ (i,o,o) (o,i,o) (o,o,i).
rubRuleTypeSet : (string) determ (i).
rubRuleTypeSel : (string) determ (i).
rubSC_Adj : (sterm,sterm) procedure (i,o).
rubSetNo : (sterm,integer,sterm) determ (i,i,o).
rubSimpleVar : (string,string,string_list,string) determ (i,i,i,o).
rubST_NodeDEs : (sterm,sterml) determ (i,o).
rubSubGet : (sterm,integer,sterm) determ (i,i,o).
rubSubRep : (sterm,integer,sterm,sterm) determ (i,i,i,o).
rubTreeClean : (integer,vpiDomains::windowHandle,sterm,sterm) determ (i,i,i,o).
rubTreeGetCurr : (sterm,vpiDomains::windowHandle,sterm) determ (i,i,o).
rubTW_Get : (vpiDomains::windowHandle,vpiDomains::windowHandle) determ (i,o).
rubEW_Get : (vpiDomains::windowHandle,vpiDomains::windowHandle) determ (i,o).
rubValidate : (sterm,sterm) determ (i,o).
rubValidateInsNIL : (integer_list) determ (i).
rubVarHasRef : (string,sterm) determ (i,i).
rubVarExists : (string,string_list,string) determ (i,i,o).
rubVariables : (sterm,integer,string_list) determ  (i,i,o).
end class rub