/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class sol
open core,termDomain

predicates
classInfo : core::classInfo.
        % @short Class information  predicate. 
        % @detail This predicate represents information predicate of this class.
        % @end
dropSolSet : (integer).
addSolSet : (integer,string_list).
exSolSet : (integer,string_list) determ.

forallsol : (integer,integer) nondeterm (i,o).
forallsolsorted : (integer SolRef,integer First,integer LNo,integer PNo) nondeterm (i,i,o,o).
solCompNo : (integer,integer,integer,sterm) determ (i,i,i,o).
solCompNoReplace : (integer,integer,integer,sterm) determ (i,i,i,i).
solVarReplace : (integer,integer,string,sterm) determ (i,i,i,i).
solComps : (integer,integer,string_list) determ (i,o,o).
solCompsT : (integer,integer,sterml) determ (i,o,o).
solCompVar : (integer,integer,string,sterm) determ (i,i,i,o).
solCopyRec : (integer,integer,integer) determ (i,i,i).
solDel : (integer,integer) procedure (i,i).
solFirstL : (integer,integer) determ (i,o).
solGet : (integer,integer,sterml) determ (i,i,o).
solIns : (integer,globalRefDomains::env) determ (i,i).
solInsVals : (integer,sterml,sterml) determ (i,i,i).
solInsVRec : (integer,sterml,integer) determ (i,i,i).
solNoVar : (integer,integer,string) determ (i,i,o).
solSetDel : (integer) determ (i).
solSetDelAll : () procedure.
solSetDelAltered : () procedure.
%solSetDelCond : (integer) procedure (i). always use solSetDel
solSetDelInternal : () procedure.
solSetEnumerate : (integer) determ (i).
% solSetExists : (sterm,integer) determ (i,o). not needed 27.5.5
solSetHeader : (integer,integer,integer,integer,sterm,integer) determ (i,o,o,o,o,o).
solSetMarkAltered : (integer) determ (i).
solSetNew : (sterm,integer) determ (i,o).
solSetNCompsSet : (integer,integer) determ (i,i).
solSetSize : (integer,integer) determ (i,o).
solSetSizeSet : (integer,integer) determ (i,i).
solSetToSentenceTerms : (string,integer,sterml) determ (i,i,o).
solSetTracedSet : (integer) procedure (i).
solSort : (integer,integer_list) determ.
solST_Var : (string,string,string_list) determ (i,o,o).
solSwap : (integer,integer,integer) determ (i,i,i).
solVarNo : (integer,string,integer) determ (i,i,o).
solVarNos : (integer,string_list,integer_list) determ (i,i,o).

tt_sors : (integer,string,integer).
end class sol