/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

/* db independent */

class transnl
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.
scnSyntagmSets : (pie_scan::tokl,sterml,sterml_list) determ (i,i,o).
nl_tok_scan : (pie_scan::tokl,sterml,sterml_list,pie_scan::wrds) nondeterm (i,i,i,o).
parCompSynTree : (string NL,sterm SyntaxTree) determ (i,o).
parNL_PR : (string NL,string PR) determ (i,o).
parParameters : (string,sterml,sterml) determ (i,i,o).
parSynTree : (string NL,sterm SynTree) procedure (i,o).
parTranslate : (string NL,sterm IF,string TermType) determ (i,o,o).
queryDom : (sterm,string) procedure (i,o).
scnNL : (string,pie_scan::wrds) nondeterm (i,o).
scnText : (string,string,string,string) determ (i,i,o,o).
scnTextBlock : (string,string,string_list,string) determ (i,i,o,o).
transQuery : (string,sterm,string) determ (i,o,o).
end class transnl