/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

interface xmlTree
open core,termDomain
predicates
% returns
% xml-tree --> xml
get : () -> sterm. % returns the xml-tree
getX : (integer Indent) -> string determ. % returns the xml-tree as an xml string with given indentation [formerly xmlFromTree]
getAllOfTag : (string Tag)->string_list determ. % returns the contents of all occurrences of given Tag (which must be non-complex) as a list where each element corresponds to a tag content. 
getSubTree : (string Tag) -> sterm determ.% returns the sub-tree with given Tag as root - fails if no such Tag exists
getTagValueAfterTag : (string Tag,string TagValue,string NextTag) -> string determ. % gets the first value of tag 'NextTag' occurring after and on the same level as tag 'Tag' with value 'TagValue'
end interface xmlTree