/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

interface lst
open core

predicates

add : (string) procedure.
addList : (string_list) procedure.
addUnique : (string) procedure.
delete : (string) procedure.
deleteAll : ().
deleteTop : () determ. % note: fails if list is empty
get : () -> string_list.
get_nd : () -> string nondeterm.
getNext: (integer Count,string Next,integer NextCount) nondeterm (i,o,o). % returns members nondeterministically according to descending count
getCount : () -> integer.
getSorted : () -> string_list.
member : (string Member) determ.
size : () -> integer.
sort : () determ. % sorts the list, such that e.g. get_nd will retrieve in sorted sequence
top : () -> string determ. % the most recently inserted string in the list

end interface lst