/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

implement dbLocation
open core,globalDomains

constants
className = "com/rudstrand/dbLocation/dbLocation".
classVersion = "1.0".

facts
hasLoc : integer := -1. % -1/1 loc contains an address 
loc : dbLoc. 

clauses
classInfo(className, classVersion).

new() :-
    hasLoc:=-1,
    loc:=sloc("",0),
    !.
    
new(Loc) :-
    hasLoc:=1,
    loc:=Loc,
    !.

equal(Loc) :-
    hasLoc=1,
    loc=Loc,
    !.
    
get()=Loc :-
    hasLoc=1,
    Loc=loc,
    !.

set(Loc) :-
    hasLoc:=1,
    loc:=Loc,
    !.
    
end implement dbLocation
