/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

/* 3kb dependent */

class dbaUtil
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.

dbaBackup : (integer Backup,string KB) determ.
dbaCheckDB_Id : (string Id) determ (o).
dbaCloseAux : (chainDB DB) determ.
dbaCloseBasic : (chainDB DB,char IxChar) determ.
dbaCountChain : (string Chain,integer N) determ (i,o).
dbaCountRealm : (chainDB,string Realm,integer N) procedure (i,i,o).
dbaDeleteChain : (chainDB DB,string Chain) determ.
dbaDeleteKB_Realm : (string_list KB_Files,string Realm) determ. % uses dbaDeleteRealmKB - handles mass-update
dbaDeleteRealmKB : (chainDB DB,string Realm) determ. % graphs and indexes are up-to-date when completed - handles mass-update
dbaFlagON : (string FileName,string Flag) determ.
dbaFlagSet : (string KBfile,string Flag,integer Value) determ.
dbaIxRegenAll : () determ.
dbaOpenAuxDB : (string,chainDB) determ (i,o).
dbaOpenRegenIx : ().
dbaOpenRestore : (integer,string) determ.

% returns KB&Ref for a cert. rule
dbuCR_GetRef : (string,sterm,sterml,chainDB,chainDB::ref,string,integer) determ (i,o,o,o,o,o,o).
dbuCR_GetRefF : (string,sterm,sterml,chainDB,chainDB::ref,string,integer) determ (i,o,o,o,o,o,o).
% changes/sets record type for a given record 
dbuChangeRecType : (chainDB,chainDB::ref,integer) determ (i,i,i).
% returns a record's realm
dbuRealmC : (string,chainDB::ref,chainDB,string) determ (i,i,o,o).
dbuRealmNo : (chainDB,chainDB::ref,string,integer,integer) procedure (i,i,o,o,o).
dbuRealmNoC : (string,chainDB::ref,chainDB,string,integer,integer) determ (i,i,o,o,o,o).
getCR_TermF : (string,sterm,chainDB::ref) determ (i,o,o). % returns the body (left term) and ref of an IR (fails if none)
% returns KB+address for a given DBRF key
dbuDBRF : (string,chainDB,chainDB::ref) determ (i,o,o).
% inserts given public chains
dbuPubChainsIns : (chainDB,string,string_list) determ (i,i,i).
dbuRuleRef : (string,chainDB,chainDB::ref) determ (i,o,o).
% returns KB+ref for a rule-key
dbuGetInRealm : (string,string,integer,integer,chainDB,chainDB::ref) determ (i,i,i,i,o,o).	
% returns a list of all recods (KbId|Address) of given record type
dbuGetRecTypes : (integer,dbLoc_list) determ (i,o).
% returns no. of index entries for given index and key front-string 
dbuIxCountFront : (string,string,integer) determ (i,i,o).
end class dbaUtil