/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class dom
open core,termDomain

predicates
classInfo : core::classInfo.
domAtom : (string) determ (i).
domStr : (string) determ (i).
domInt : (string) determ (i).
domFix : (string) determ (i).
domXmlDt : (string) determ (i).
domStatProc : (string) determ.
domNum : (string) determ (i).
listDomain : (string ListDomain,string Domain) determ (i,o).  
% adjusts a term to its domain
domAdjustTerm : (sterm,string,sterm) determ (i,i,o).
% checks compatibility of domains
domCompat : (string,string) determ (i,i).
domCompatF : (string,string) determ (i,i).
%domCompatMess(string,string) determ (i,i)
% checks compatibility of domain and value
domValCompat : (string,sterm) determ (i,i).
domValCompatF : (string,sterm) determ (i,i).
% all domains (KB name)
domAll : (string) multi (o).
domAll : (string) determ (i).
domAllSuffix : (string) multi (o).
domAllSuffix : (string) determ (i).
% list of all domains (KB name)
nlList : () -> string_list determ. % domains (NL) sorted (non-list domains followed by list domains)
domList : (string_list) procedure (o).
domListNL : (string_list) procedure (o).
% maps between short domain indicator and KB domain name
domShortLong : (string,string) determ (i,i) (i,o) (o,i).
domShortLongF : (string,string) determ (i,i) (i,o) (o,i).
% checks if value is in domain range
domInRange : (string,real) determ (i,i).
% ensures that a path ends with back-slash
end class dom