/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class opr
open core

predicates
        classInfo : core::classInfo.
        % @short Class information  predicate. 
        % @detail This predicate represents information predicate of this class.
        % @end
% checks if string is an operator of given cardinality
opr_any : (string,integer) determ (i,i) (i,o).
% checks if string is an assignment/comparison operator
opr_cmpass : (string) determ (i).
% checks if string is an assignment/equality operator
oprEq : (string) determ (i).
%oprEqDom(string) determ (i)
% checks if string is domain-specific assignment operator
%oprAssDom(string) determ (i)
% checks if string is an inter-expression operator of given cardinality
opr_expr : (string,integer) determ (i,i) (i,o).
% fails if not comparison operator
oprCmp : (string) determ (i).
oprDom : (string,string,string) determ (i,i,o) (o,o,i).
oprDomF : (string,string,string) determ (i,i,o) (o,o,i).
% converts between internal and external assignment operator format
oprIntExt : (string,string) procedure (i,o) (o,i).
end class opr