/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class stb
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.

stbA_Get : (integer,integer,integer,string,string,integer) procedure (i,i,i,o,o,o).
stbA_Insert : (integer,integer,integer,string,string,integer) determ (i,i,i,i,i,i).
stbCellGet : (integer,integer,integer,integer,string,sterm) procedure (i,i,i,i,o,o).
stbCellGetF : (integer,integer,integer,integer,string,sterm) determ (i,i,i,i,o,o).
stbCellInsert : (integer,integer,integer,integer,string,sterm) determ (i,i,i,i,i,i).
stbD_GetArg : (integer,integer,integer,integer,integer,string,string,string,string,integer,integer,integer,integer) determ (i,i,i,i,o,o,o,o,o,o,o,o,o).
stbD_GetCol : (integer,integer,integer,integer,integer,string,string,string,string,integer,integer,integer,integer) determ (i,i,i,o,o,o,o,o,o,o,o,o,o).
stbD_GetColWidths : (integer,integer,integer_list,integer_list) determ (i,i,o,o).
stbD_Insert : (integer,integer,integer,integer,integer,string,string,string,string,integer,integer) determ (i,i,i,i,i,i,i,i,i,i,i).
stbD_SetDE_NL : (integer,integer,integer,string) determ (i,i,i,i).
stbD_SetSort : (integer,integer,integer,integer) determ (i,i,i,i).
stbD_SetSortV : (integer,integer,string,integer,integer) determ (i,i,i,i,i).
stbDeleteAll : ().
deleteRow : (integer SolRef,integer Table,integer Row) determ.
stbDeleteSolAll : (integer) procedure (i).
stbDeleteTable : (integer,integer) procedure (i,i).
stbDisplaySet : (integer,integer,integer,integer,integer,integer,integer) determ (i,i,i,i,i,i,i).
foralltable : (integer,integer,integer,integer) nondeterm (i,i,o,o).
foralltbl : (integer,integer,integer) nondeterm (i,i,o).
foralltblsorted : (integer,integer,integer,integer) nondeterm (i,i,o,o).
foralltblsorteddec : (integer,integer,integer,integer) nondeterm (i,i,o,o).
stbGetRowL_P : (chainDB::bt_selector,integer,integer) determ (i,i,o).
stbGetRowL_PZ : (chainDB::bt_selector,integer,integer) determ (i,i,o).
stbGetRowL_P_F : (chainDB::bt_selector,integer,integer) determ (i,i,o).
stbH_Get : (integer,integer,integer,integer,string,integer,integer,integer) procedure (i,i,o,o,o,o,o,o).
stbH_IncRows : (integer,integer,integer) determ (i,i,o).
stbH_Insert : (integer,integer,integer,integer,string) determ (i,i,i,i,i).
stbH_SetNRows : (integer,integer,integer) determ (i,i,i).
stbH_SetSort : (integer,integer,integer) determ (i,i,i).
stbH_SetSortOrder : (integer,integer,integer) determ (i,i,i).
stbIsSorted : (integer,integer,integer) procedure (i,i,o).
stbM_DecrNTables : (integer) procedure (i).
stbM_Get : (integer,integer,string,string,integer,integer) procedure (i,o,o,o,o,o).
stbM_GetF : (integer,integer,string,string,integer,integer) determ (i,o,o,o,o,o).
stbM_Insert : (integer,integer,string,string,integer,integer) determ (i,i,i,i,i,i).
stbM_SetNTables : (integer,integer) determ (i,i).
makeData : (integer SolRef,integer Table,integer Sorted,integer First,integer Last,integer NCols,vpiTableed::tableedit_DATA Data) procedure (i,i,i,i,i,i,o).
openTableWindow : (integer SolRef,integer Table) determ.
stbRecord : (integer,integer,integer,sterm) determ (i,i,i,o).
stbRef : (integer,integer,integer,dbLoc) determ (i,i,i,o).
reOpen : (integer SolRef,integer TabNo) determ.
stbSort : (integer,integer) determ (i,i).
stbSortDelRow : (integer,integer,integer) determ (i,i,i).
stbST : (integer,string,integer) determ (i,i,o).
end class stb