/*****************************************************************************

                        Copyright (c) Jens H. Holm

******************************************************************************/

class tt
open core,termDomain,globalDomains

predicates
classInfo : core::classInfo.

getFile : () -> string.
setFile : (string).
getLevel : () -> integer.
setLevel : (integer) determ.
getClose : () -> integer.
setClose : (integer).

memory : (integer Level,string Header).

stopProfile : ().
startProfile : (string).

tt_cc : () procedure.
tt_close : ().
tt_co : () determ.
tt_header : (integer Level,string S) procedure.
ttHeader : (integer Level,string Type,string Header) determ.
tt_n : (integer Level,string Header,real R) procedure.
tt_i : (integer Level,string Header,integer I) procedure.
tt_is : (integer Level,string Header,integer_list L) procedure.
tt_iss : (integer Level,string Header,integer_list_list L) procedure.
tt_open : () determ.
tt_pie : (integer Level,integer,integer) procedure.
reset : () determ.
ttPieS : (string,string).
ttPieT : (string,sterm).
tt_s : (integer Level,string Header,string S) procedure.
tt_ss : (integer Level,string S) procedure.
tt_strings : (integer Level,string Header,string_list L) procedure.
tt_stringss : (integer Level,string Header,string_list_list L) procedure.
tt_table : (integer,string,integer).
tt_term : (integer Level,string Header,sterm T) procedure.
tt_terms : (integer Level,string Header,sterml L) procedure.
tt_termslist : (integer Level,string Header,sterml_list L).
tt_tokl : (integer Level,string Header,pie_scan::tokl L).
tt_wrd : (integer Level,string Header,pie_scan::wrd W).
tt_wrds : (integer Level,string Header,pie_scan::wrds L).
wr : (string_list L).
wrl : (string_list L).

freeMemory : (real,real,real,real,real,real,real,real) determ (o,o,o,o,o,o,o,o).
end class tt